; #########################################################################
.NOLIST			;signifie: ne rien mettre dans le listing
;------ emplacement des dclarations
	.386
	.model flat, stdcall
	option casemap :none   ; case sensitive

	include translate.inc
	include windows.sdk
	include objbase.sdk
	include macro.inc
	include f:\masm32\include\masm32.inc
	include f:\masm32\include\perso32.inc	
	includelib kernel32.lib
	includelib user32.lib
	includelib ole32.lib
	includelib oleaut32.lib
	includelib f:\masm32\lib\masm32.lib	
	includelib f:\masm32\lib\perso32.lib
; 9.0 sIID_Help2	TEXTEQU	<{078413D2Dh,00492h,04A9Bh,{0ABh,025h,073h,006h,033h,067h,099h,077h}}>
;IHelp2 sIID_Help2	TEXTEQU	<{02806F21Fh,0047C7h,049FCh,{0B8h,0F0h,014h,005Ch,050h,092h,01Bh,024h}}>
sIID_Help2 TEXTEQU <{04A791148h,019E4h,011D3h,{0B8h,06Bh,000h,0C0h,04Fh,079h,0F8h,002h}}>
;2806F21F-47C7-49FC-B8F0-145C50921B24
	STHelp2	STRUCT
		QueryInterface               	comethod3 ?
		AddRef                       	comethod1 ?
		Release                      	comethod1 ?
		GetTypeInfoCount             	comethod2 ?
		GetTypeInfo                  	comethod4 ?
		GetIDsOfNames                	comethod6 ?
		invoke1                      	comethod9 ?	
		;---- end Idispatch ----------------------
		; Contents Index 	Search Close Collection HowDoI Favorites	
		Contents                     	comethod1 ?
		Index                        	comethod1 ?
		Search                       	comethod1 ?
		IndexResults                 	comethod1 ?
		SearchResults                	comethod1 ?
		DisplayTopicFromId           	comethod3 ?
		DisplayTopicFromURL          	comethod2 ?
		DisplayTopicFromURLEx        	comethod3 ?
		DisplayTopicFromKeyword      	comethod2 ?
		DisplayTopicFromF1Keyword    	comethod2 ?
		DisplayTopicFrom_OLD_Help    	comethod3 ?
		SyncContents                 	comethod2 ?
		CanSyncContents              	comethod2 ?
		GetNextTopic                 	comethod2 ?
		GetPrevTopic                 	comethod2 ?
		FilterUI                     	comethod1 ?
		CanShowFilterUI              	comethod1 ?
		Close                        	comethod1 ?
		SyncIndex                    	comethod3 ?
		SetCollection                	comethod3 ?
		Collection                   	comethod1 ?
		Filterout                    	comethod1 ?
		Filterin                     	comethod2 ?
		FilterQuery                  	comethod1 ?
		HelpOwnerout                 	comethod1 ?
		HelpOwnerin                  	comethod2 ?
		HxSession                    	comethod1 ?
		Help                         	comethod1 ?
		GetObject1                   	comethod3 ?
		;-------- 9.0----------------------------
		SearchEx                     	comethod4 ?
		HowDoI                       	comethod1 ?
		Favorites                    	comethod1 ?
		AskAQuestion                 	comethod2 ?
		DisplayTopicFromURLEx2       	comethod4 ?
		InitializeSettingsToken      	comethod2 ?		
	STHelp2	ENDS
Help2 MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STHelp2 PTR[edx]).>,<&Function,ppvHelp2>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvHelp2
    mov edx, [edx]
    InvokeInterface
ENDM		

GetInterfaceFromProgId PROTO :DWORD,:DWORD
ShowTopic PROTO :DWORD,:DWORD
IFNDEF CLSCTX_ALL
CLSCTX_ALL	equ	< CLSCTX_INPROC_SERVER OR \
		 CLSCTX_INPROC_HANDLER OR \
		 CLSCTX_LOCAL_SERVER OR \
		 CLSCTX_REMOTE_SERVER>
ENDIF
	
; #########################################################################
	
.const
.data

ppvHelp2 dd 0 
IID_Help2 GUID sIID_Help2
.code
;@@@@@@@@@@@@@@@@@@@@@@@      POINT d'ENTREE  du code, start:    @@@@@@@@@@@@@@@@@@@@@@
start:
;--------------------- a mettre en premier ----------------------------
		Invoke CoInitialize,NULL
		invoke OleInitialize,NULL
		;SADR("DExplore.AppObj.9.0") works also
		invoke GetInterfaceFromProgId,SADR("DExplore.AppObj"),addr IID_Help2
		.if eax > 10
			mov ppvHelp2,eax
			; Contents Index 	Search Close Collection HowDoI Favorites	
			;Help2 Index
			;Help2 Favorites
			;Help2 Collection
			;"ms-help://MS.LHSMSSDK.1033/MS.LHSWinSDK.1033" works also
			invoke ShowTopic,SADR("ms-help://MS.LHSMSSDK.1033"),
				SADR("SysAllocString")
				;"ms-help://MS.LHSMSSDK.1033/MS.LHSWinSDK.1033/automat/html/9e0437a2-9b4a-4576-88b0-5cb9d08ca29b.htm"
			;Help2 Help
			invoke Sleep, 30000	;30s		
			Help2 Release
		.endif
		invoke OleUninitialize	
		invoke CoUninitialize
	
	invoke ExitProcess,0
;################################################################
ShowTopic PROC pCollection:DWORD,pszTopic:DWORD
	LOCAL wszCollection[1024]:Word
	LOCAL wszTopic[1024]:Word
	LOCAL wszNull[64]:Word
	LOCAL pbstrTopic:DWORD,pbstrCollection,bstrFilter,pbstrFilter
	ZEROLOCALES pbstrFilter
	
	invoke MultiByteToWideChar,CP_ACP,NULL,pCollection,-1,addr wszCollection,1024

	invoke SysAllocString,addr wszCollection
	mov pbstrCollection,eax

	;SetCollection
	invoke MultiByteToWideChar,CP_ACP,NULL,addr bstrFilter,-1,addr wszNull,sizeof wszNull
	invoke SysAllocString,addr wszNull
	mov  	pbstrFilter,eax
	;
	Help2 SetCollection,pbstrCollection,pbstrFilter	;filtre null
	invoke SysFreeString,pbstrCollection
	invoke SysFreeString,pbstrFilter
	;Help2 Contents
	;ready ?
	invoke MultiByteToWideChar,CP_ACP,NULL,pszTopic,-1,addr wszTopic,1024
	invoke SysAllocString,addr wszTopic
	mov pbstrTopic,eax

	Help2 DisplayTopicFromKeyword,pbstrTopic
	;Help2 SyncIndex,pbstrTopic,1
	;Help2 Search
	
	;Help2 Index

	invoke SysFreeString,pbstrTopic
	RET
ShowTopic ENDP
GetInterfaceFromProgId PROC pProgId:DWORD,pIID:DWORD
	LOCAL wszProgID[1024]:word
	LOCAL ppv:Dword,retour		
	LOCAL clsid	:GUID
	mov retour,0
	invoke MultiByteToWideChar,CP_ACP,MB_PRECOMPOSED,pProgId,-1,addr wszProgID,sizeof wszProgID
	invoke CLSIDFromProgID,addr wszProgID,addr clsid
	.if eax == S_OK
		invoke CoCreateInstance,addr clsid, NULL,CLSCTX_ALL,pIID,addr ppv
		.if eax == S_OK 
			PuPo retour,ppv
		.elseif eax == REGDB_E_CLASSNOTREG		;for debugging use
			mov retour,2		
		.elseif eax == E_OUTOFMEMORY
			mov retour,3		
		.elseif eax == E_INVALIDARG
			mov retour,3		
		.elseif eax == E_UNEXPECTED
			mov retour,4		
		.elseif eax == CLASS_E_NOAGGREGATION
			mov retour,5		
		.else
			mov retour,6
		.endif
	.endif
	mov eax,retour
	RET
GetInterfaceFromProgId endp
;################################################################
end start

